from EasyExtend.cst2source import*
import unittest
import parser
from test import test_support

class TestUnparser(unittest.TestCase):
    def roundtrip(self, S0):
        tree0  = parser.suite(S0).tolist()
        tree2s0 = Unparser()
        src0 = tree2s0(tree0)
        tree1  = parser.suite(src0).tolist()
        tree2s1 = Unparser()
        src1 = tree2s1(tree1)
        self.assertEqual(src1,src0)

    def test_1(self):
        self.roundtrip("m = 2\nfor x in range(10):\n for y in range(9):\n   print y\n i+=0")

    def test_2(self):
        self.roundtrip("def test(x):\n  if x:\n    y=x\n    return x\n  else:\n    return 0")

    def test_3(self):
        self.roundtrip("def test(x):\n  if x:\n    return x\n  else:\n    return 0\n  if x+1:\n    if x:\n      return x")

    def test_4(self):
        self.roundtrip("def test(x):\n  if x :\n    return x\n  elif x < 0 :\n    return 0")

    def test_5(self):
        self.roundtrip("if a:\n  print 6\nelif b:\n  print 7")


def test_main():
    test_support.run_unittest(TestUnparser)


if __name__ == "__main__":
    test_main()

