
#
  # This test requires Py25Lite to run
#

import __fiber__
import unittest
from test import test_support     # bla

# blub

class TestTry(unittest.TestCase):
    def test_try_finally_std(self):
        x = 0
        try:
            try:
                1/0
            finally:
                x = 1
        except ZeroDivisionError:
            pass

        self.assertEqual(x,1)

    def test_try_excpt_finally(self):
        x = 0
        try:
            1/0
        except ZeroDivisionError:
            x +=1
        finally:
            x +=1
        self.assertEqual(x,2)

    def test_try_excpt_finally_with_exc_error(self):
        x = 0
        try:
            try:
                1/0
            except ZeroDivisionError:
                x +=1
                1/0
            finally:
                x +=1
        except ZeroDivisionError:
            x+=1
        self.assertEqual(x,3)

    def test_try_excpt_finally_with_finally_error(self):
        x = 0
        try:
            try:
                1/0
            except ZeroDivisionError:
                x +=1
            finally:
                x +=1
                1/0
        except ZeroDivisionError:
            x+=1
        self.assertEqual(x,3)

    def test_try_finally_with_finally_error(self):
        x = 0
        try:
            try:
                x +=1
            finally:
                x +=1
                1/0
        except ZeroDivisionError:
            x+=1
        self.assertEqual(x,3)

    def test_try_except_finally_with_closure(self):
        x = 0
        try:
            def f(y):
                try:
                    1/0
                except ZeroDivisionError:
                    y +=1
            f()
        except Exception:
            pass
        finally:
            x +=1
        self.assertEqual(x,1)

    def test_multiple_except_clauses(self):
        def f():
            try:
                try:
                    1//0
                except ZeroDivisionError:
                    yield 666
                except ValueError:
                    pass
            finally:
                pass

def test_main():
    test_support.run_unittest(TestTry)

if __name__ == "__main__":
    test_main()

