#
# This test requires gallery to run
#
import __fiber__
import unittest
import funcs
from test import test_support


class TestGallery(unittest.TestCase):
    def test_repeat_until_1(self):

        x = 9
        repeat:
            x-=1
        until:
            x==3

        self.assertEqual(x,3)

    def test_repeat_until_2(self):
        x = 9
        repeat:
            x-=1
        until: x==3
        self.assertEqual(x,3)

    def test_on_stmt_1(self):

        def f(x):
            on m = x:
                return m+1
            return x

        self.assertEqual(f(0),0)
        self.assertEqual(f(1),2)

    def test_on_stmt_2(self):
        x = -1
        try:
            on m=0:
                on m=0:
                    0
                else:
                    1
            else:
                1/0
        except ZeroDivisionError:
            x = 0
        self.assertEqual(x,0)


    def test_mixed(self):
        d = {1:9}
        x = 0
        repeat:
            on m = d.get(x):
                x = m
                break
            else:
                x+=1
        until: x==3
        self.assertEqual(x,9)

    def test_importer(self):
        import gallery.fiber as fiber


    def test_chainlet(self):
        A = Chainlet()
        B = Chainlet()
        A1  = A()
        A11 = A1()
        A111= A11()
        B1  = B()
        B11 = B1()
        B12 = B1()
        C = A111
        r = None
        switch C:
            case A:
                r = A
            case A11:
                r = A11
            case A111:
                switch 1:
                    case 0:
                        r = 99
                    case 2:
                        r = 100
                else:
                    r = A111
        else:
            r = "No co-selection NOK"
        self.assertEqual(r,A111)

def test_main():
    test_support.run_unittest(TestGallery)

if __name__ == "__main__":
    test_main()

